diff --git a/logrotate.c b/logrotate.c
index cd1d430f..251bceba 100644
--- a/logrotate.c
+++ b/logrotate.c
@@ -1069,6 +1069,20 @@ static int copyTruncate(char *currLog, char *saveLog, struct stat *sb,
     return 0;
 }
 
+/* return value similar to mktime() but the exact time is ignored */
+static time_t mktimeFromDateOnly(const struct tm *src)
+{
+    /* explicit struct copy to retain C89 compatibility */
+    struct tm tmp;
+    memcpy(&tmp, src, sizeof tmp);
+
+    /* abstract out (nullify) fields expressing the exact time */
+    tmp.tm_hour = 0;
+    tmp.tm_min  = 0;
+    tmp.tm_sec  = 0;
+    return mktime(&tmp);
+}
+
 int findNeedRotating(struct logInfo *log, int logNum, int force)
 {
     struct stat sb;
@@ -1162,16 +1176,10 @@ int findNeedRotating(struct logInfo *log, int logNum, int force)
 	       state->lastRotated.tm_hour != now.tm_hour) {
 	switch (log->criterium) {
 	case ROT_WEEKLY:
-	    /* rotate if:
-	       1) the current weekday is before the weekday of the
-	       last rotation
-	       2) more then a week has passed since the last
-	       rotation */
-	    state->doRotate = ((now.tm_wday < state->lastRotated.tm_wday)
-			       ||
-			       ((mktime(&now) -
-				 mktime(&state->lastRotated)) >
-				(7 * 24 * 3600)));
+	    /* rotate if date is advanced by 7+ days (exact time is ignored) */
+	    state->doRotate =
+		((mktimeFromDateOnly(&now) -
+		  mktimeFromDateOnly(&state->lastRotated)) >= (7 * 24 * 3600));
 	    if (!state->doRotate) {
 	    message(MESS_DEBUG, "  log does not need rotating "
 		    "(log has been rotated at %d-%d-%d %d:%d, "
